/*
 *  USB_VendorProductIDs.h
 *  macam
 *
 *  Created by HXR on 6/29/05.
 *  Copyright 2005 HXR. GPL applies.
 *
 */

// This file should contain, vendor, product, and a comment with the name of the driver that recognizes the camera

#define VENDOR_KODAK			0x040a
#define	PRODUCT_EZ200                   0x0300		// SPCA500A

#define VENDOR_CREATIVE_LABS    0x041e
#define	PRODUCT_PC_CAM_300              0x400a		// SPCA500A
#define	PRODUCT_PC_CAM_600              0x400b		// SPCA504C
#define PRODUCT_WEBCAM_5                0x400c
#define PRODUCT_WEBCAM_5_NEW            0x400d
#define PRODUCT_WEBCAM_PRO_EX           0x4011
#define PRODUCT_PC_CAM_350              0x4012      // SPCA504C
#define PRODUCT_PC_CAM_750              0x4013      // SPCA504B
#define PRODUCT_WEBCAM_MOBILE           0x4017      // ZC0301P
#define PRODUCT_VISTA_A                 0x4018      // SPCA508
#define PRODUCT_VISTA_B                 0x401a      // SPCA561A
#define PRODUCT_WEBCAM_NOTEBOOK         0x401f      // ZC0301P
#define PRODUCT_CREATIVE_NX             0x401c      // ZC0301
#define PRODUCT_CREATIVE_INSTANT_A      0x4034      // ZC0301
#define PRODUCT_CREATIVE_INSTANT_B      0x4035      // ZC0301
#define PRODUCT_CREATIVE_NX_PRO         0x401e      // ZC0301P
#define PRODUCT_CREATIVE_NX_PRO2        0x403a      // ZC0301P
#define PRODUCT_CREATIVE_LIVE           0x4036      // ZC0301P
#define PRODUCT_VISTA_C                 0x403b      // SPCA561A
#define PRODUCT_VISTA_PLUS              0x4028      // PAC207
#define PRODUCT_CREATIVE_LIVE_CAM_NTB_P 0x4051      // VC301P
#define PRODUCT_CREATIVE_LIVE_VISTA_IM  0x4052      // OV519
#define PRODUCT_CREATIVE_LIVE_CAM_VIM   0x4053      // VC301P

#define VENDOR_GENIUS           0x0458
#define PRODUCT_VIDEOCAM_EXPRESS_V2     0x7004      // SPCA561A
#define PRODUCT_DSC_13M_SMART           0x7006      // SPCA504B-P3
#define PRODUCT_VIDEOCAM_V2             0x7007      // ZC0301P
#define PRODUCT_VIDEOCAM_V3             0x700c      // ZC0301P
#define PRODUCT_VIDEOCAM_WEB            0x700f      // ZC0301P

#define VENDOR_MICROSOFT        0x045e
#define PRODUCT_LIFECAM_VX_1000         0x00f7      // SN9C105R
#define PRODUCT_LIFECAM_VX_3000         0x00f5      // SN9C105R
#define PRODUCT_LIFECAM_VX_6000         0x00f4      // SN9C202
#define PRODUCT_LIFECAM_NX_6000         0x00f8      // OV531?
#define PRODUCT_XBOX_VIDEO_CHAT         0x028c      // in Japan only?
#define PRODUCT_XBOX_LIVE_VISION        0x0294      // UVC chipset

#define VENDOR_MICRO_INNOVATION 0x0461
#define PRODUCT_IC_100                  0x0815      // SPCA561A
#define PRODUCT_IC_150                  0x0815      // SPCA561A
#define PRODUCT_IC_200                  0x0815      // SPCA508A
#define PRODUCT_WEBCAM_320              0x0a00      // ZC030x

#define VENDOR_LOGITECH			0x046d
#define VENDOR_LABTEC			0x046d
#define PRODUCT_QUICKCAM_HOME           0x0801
#define PRODUCT_QUICKCAM_PRO_BEIGE      0x0810      // uses USS720 USB <-> parallel converter
#define PRODUCT_QUICKCAM_PRO_DARK       0xd001      // DIVIO NW801 controller

#define PRODUCT_QUICKCAM_EXPRESS_A      0x0840
#define PRODUCT_QUICKCAM_WEB            0x0850
#define PRODUCT_QUICKCAM_EXPRESS_B      0x0870
#define PRODUCT_QUICKCAM_TRAVELER       0x0890

#define PRODUCT_ORBICAM_A               0x0892      // VC032x ?
#define PRODUCT_ORBICAM_B               0x0896      // VC032x ?

#define PRODUCT_QUICKCAM_IM_A           0x08a0      // ZC030x
#define PRODUCT_QUICKCAM_IM_MIC         0x08a1      // ZC030x
#define PRODUCT_LABTEC_WEBCAM_PRO       0x08a2      // ZC0302
#define PRODUCT_QUICKCAM_CHAT_A         0x08a3      // ZC030x
#define PRODUCT_QUICKCAM_IM_C           0x08a6      // ZC030x
#define PRODUCT_QUICKCAM_IMAGE          0x08a7      // ZC030x
#define PRODUCT_QUICKCAM_NOTEBOOK_DELUXE 0x08a9     // ZC0302
#define PRODUCT_LABTEC_NOTEBOOKS        0x08aa     // ZC0302
#define PRODUCT_QUICKCAM_COOL           0x08ac     // ZC030x
#define PRODUCT_QUICKCAM_COMMUNICATE_STX 0x08ad     // ZC0302
#define PRODUCT_QUICKCAM_NOTEBOOKS_B    0x08ae      // ZC030x, round one, zc0302

#define PRODUCT_QUICKCAM_PRO_3000       0x08b0
#define PRODUCT_QUICKCAM_NOTEBOOK_PRO   0x08b1      // 740 (CCD)
#define PRODUCT_QUICKCAM_PRO_4000       0x08b2
#define PRODUCT_QUICKCAM_ZOOM           0x08b3
#define PRODUCT_QUICKCAM_ZOOM_NEW       0x08b4
#define PRODUCT_QUICKCAM_ORBIT          0x08b5
#define PRODUCT_CISCO_VT_ADVANTAGE      0x08b6
#define PRODUCT_QUICKCAM_IM_B           0x08b9      // ZC030x

#define PRODUCT_QUICKAM_NEW0            0x08c0
#define PRODUCT_QUICKAM_FUSION          0x08c1
#define PRODUCT_QUICKAM_ORBIT_MP        0x08c2
#define PRODUCT_QUICKAM_PRO_NOTEBOOKS   0x08c3
#define PRODUCT_QUICKAM_NEW4            0x08c4
#define PRODUCT_QUICKAM_PRO_5000        0x08c5
#define PRODUCT_QUICKAM_OEM_DELL_NTBK   0x08c6
#define PRODUCT_QUICKAM_OEM_CISCO_VT_II 0x08c7
#define PRODUCT_QUICKAM_UPDATEME        0x08cf

#define PRODUCT_QUICKCAM_COMM_STX_PLUS  0x08d7      // ZC0302??
#define PRODUCT_QUICKCAM_NOTEBOOK_DLX_B 0x08d8      // ZC0302?? // P/N: 961400-1914
#define PRODUCT_QUICKCAM_IM_CONNECT     0x08d9      // ZC030x
#define PRODUCT_QUICKCAM_MESSENGER_C    0x08da      // ZC030x

#define PRODUCT_QUICKCAM_MESSENGER      0x08f0      // QCMessengerDriver
#define PRODUCT_QUICKCAM_COMMUNICATE    0x08f5      // QCMessengerDriver
#define PRODUCT_QUICKCAM_MESSENGER_PLUS 0x08f6      // QCMessengerDriver

#define	PRODUCT_CLICKSMART_310          0x0900
#define	PRODUCT_CLICKSMART_510          0x0901		// SPCA500A
#define	PRODUCT_CLICKSMART_820_A        0x0903
#define	PRODUCT_CLICKSMART_820_B        0x0905

#define PRODUCT_QUICKCAM_EXPRESS_C      0x0920      // TV8532
#define PRODUCT_LABTEC_WEBCAM_A         0x0921      // TV8532
#define PRODUCT_QUICKCAM_EXPRESS_D      0x0928      // SPCA561A [elch2]
#define PRODUCT_LABTEC_WEBCAM_B         0x0929      // SPCA561A [elch2]
#define PRODUCT_QUICKCAM_NOTEBOOKS_A    0x092a      // SPCA561A [square one]
#define PRODUCT_LABTEC_WEBCAM_C         0x092b      // SPCA561A
#define PRODUCT_QUICKCAM_CHAT_B         0x092c      // SPCA561A
#define PRODUCT_QUICKCAM_EXPRESS_G      0x092d      // SPCA561A
#define PRODUCT_QUICKCAM_EXPRESS_F      0x092e      // SPCA561A
#define PRODUCT_QUICKCAM_EXPRESS_E      0x092f      // SPCA561A

#define PRODUCT_POCKET_CAMERA           0x0950
#define PRODUCT_CLICKSMART_420          0x0960
#define PRODUCT_POCKET_750              0x0970

#define VENDOR_PHILIPS          0x0471
#define PRODUCT_PCA645VC                0x0302
#define PRODUCT_PCA646VC                0x0303
#define PRODUCT_VESTA                   0x0307
#define PRODUCT_VESTA_PRO               0x0308
#define PRODUCT_VESTA_SCAN              0x030c
#define PRODUCT_TOUCAM_FUN              0x0310
#define PRODUCT_TOUCAM_PRO              0x0311
#define PRODUCT_TOUCAM_PRO_3D           0x0312
#define PRODUCT_TOUCAM_XS               0x0313      // Philips PCVC720K/40 (ToUCam XS)
#define PRODUCT_DMVC_1300K              0x0322      // SPCA504B
#define PRODUCT_SPC_200NC               0x0325      // VC0305
#define PRODUCT_SPC_300NC               0x0326      // VC0305
#define PRODUCT_SPC_900NC               0x0329      // Kiara
#define PRODUCT_SPC_210NC               0x032d      // VC0305
#define PRODUCT_SPC_315NC               0x032e      // VC0305?

#define VENDOR_CONNECTIX		0x0478
#define PRODUCT_QUICKCAM_VC             0x0001      // uses USS720 USB <-> parallel converter
#define PRODUCT_QUICKCLIP               0x0002

#define VENDOR_BENQ             0x04a5
#define PRODUCT_DC_1300                 0x3003      // SPCA504B
#define PRODUCT_DC_1500                 0x3008      // 

#define VENDOR_SOTEC            0x04cc
#define PRODUCT_AFINA_EYE               0x8116

#define VENDOR_JVC              0x04f1
#define PRODUCT_GC_A50                  0x1001      // SPCA504B

#define VENDOR_SUNPLUS			0x04fc
#define VENDOR_FINET_TECHNOLOGY 0x04fc
#define VENDOR_EZONICS          0x04fc
#define VENDOR_APEX_DIGITAL     0x04fc
#define VENDOR_GIGATECH_COMP    0x04fc
#define PRODUCT_GENERIC_SPCA504B        0x500c      // SPCA504B
#define PRODUCT_GENERIC_SPCA561_CAM     0x0561      // SPCA561
#define PRODUCT_EZ_CAM_III              0x0561      // SPCA561
#define PRODUCT_MINI_PENCAM13_A         0x504a      // SPCA504A [not yet]
#define PRODUCT_MINI_PENCAM13_B         0x504b      // SPCA504B
#define PRODUCT_DIGITREX_2110           0x5330      // SPCA533A [not yet]
#define PRODUCT_TDC_202A                0x5330      // SPCA533A [not yet]
#define PRODUCT_GENERIC_SPCA536A_CAM    0x5360      // SPCA536A [not yet]
#define	PRODUCT_PALMPIX_DC_85           0x7333		// SPCA500A

#define VENDOR_3COM             0x0506
#define PRODUCT_HOME_CONNECT_LITE       0x00df      // SPCA501A

#define VENDOR_VEO              0x0545
#define PRODUCT_KSX_MODELS              0x8080
#define PRODUCT_IBM_NETCAMERA           0x8002
#define PRODUCT_STINGRAY_C              0x800c
#define PRODUCT_STINGRAY_D              0x800d
#define PRODUCT_ADVANCED_CONNECT        0x810a
#define PRODUCT_STINGRAY_B              0x808b      // TV8532
#define PRODUCT_STINGRAY_A              0x8333      // TV8532
#define PRODUCT_EVISION123              0x888d

#define VENDOR_POLAROID         0x0546
#define PRODUCT_PDC_2030                0x3273      // SPCA504B
#define PRODUCT_PDC_3070                0x3155
#define PRODUCT_ION_80                  0x3191      // SPCA504B

#define VENDOR_SONY             0x054c
#define PRODUCT_EYE_TOY                 0x0154
#define PRODUCT_EYE_TOY_AKA1            0x0155
#define PRODUCT_EYE_TOY_AKA2            0x0156
#define PRODUCT_EYE_TOY_AKA3            0x0157

#define VENDOR_STM              0x0553
#define PRODUCT_STV0680                 0x0202

#define VENDOR_SAMSUNG          0x055d
#define PRODUCT_MPC_C10                 0x9000
#define PRODUCT_MPC_C30                 0x9001

#define VENDOR_MUSTEK			0x055f
#define PRODUCT_GSMART_MINI2            0xc420
#define PRODUCT_GSMART_MINI3            0xc520
#define PRODUCT_WCAM_300A_A             0xd003      // ZC0301P
#define PRODUCT_WCAM_300A_B             0xd004      // ZC0301P
#define PRODUCT_WCAM_300A_C             0xc005      // ZC0302

#define VENDOR_CONEXANT         0x0572
#define PRODUCT_CN0352P_VERSION1        0x0001      // CN0352P
#define PRODUCT_CN0352P_VERSION2        0x0002      // CN0352P
#define PRODUCT_CX11646_VERSION1        0x0040      // CX11646 // Wondereye CP-115
#define PRODUCT_CX11646_VERSION2        0x0041      // CX11646 // Creative Webcam Notebook [PD1170]

#define VENDOR_OVT              0x05A9
#define PRODUCT_OV511                   0x0511
#define PRODUCT_OV511PLUS               0xA511
#define PRODUCT_OV518                   0x0518
#define PRODUCT_OV518PLUS               0xA518
#define PRODUCT_OV519                   0x0519
#define PRODUCT_OV519_AKA1              0x8519
#define PRODUCT_OV519_AKA2              0x4519
#define PRODUCT_OV530                   0x0530

#define VENDOR_RICOH            0x05ca
// many webcams integrated into laptops

#define VENDOR_DIGITAL_DREAM    0x05da
#define PRODUCT_ENIGMA_1_3              0x1018      // SPCA504B

#define VENDOR_MAXELL           0x060b
#define PRODUCT_COMPACT_PC_PM3          0xa001      // SPCA561A
#define PRODUCT_EZONICS_ICONTACT        0xa005      // SPCA561A

#define VENDOR_ALARIS           0x0620
#define PRODUCT_WEECAM                  0x0004      // QV208-02A - unknown

#define VENDOR_CHUNTEX          0x0698              // Chuntex (CTX)
#define PRODUCT_M730V_TFT               0x2003      // ZC030x

#define VENDOR_AGFA             0x06bd
#define PRODUCT_EPHOTO_CL20             0x0404      // SPCA500A [not yet]

#define VENDOR_AME_CO           0x06be
#define PRODUCT_AFINA_EYE               0x8116

#define VENDOR_HERCULES         0x06f8
#define PRODUCT_HERCULES_CLASSIC_SILVER 0x3004      // SN9C105R

#define VENDOR_VIEWQUEST		0x0733
#define PRODUCT_VQ110                   0x0110      // SPCA508A ?
#define	PRODUCT_M318B                   0x0402		// SPCA500A ?

#define	VENDOR_MATTEL			0x0813              // Products acutally labeled "Intel"
#define	PRODUCT_PLAY_QX3MICROSCOPE      0x0001
#define	PRODUCT_PLAY_ME2CAM             0x0002

#define	VENDOR_MINTON			0x084d
#define	VENDOR_D_LINK			0x084d
#define	VENDOR_TRUST			0x084d
#define	PRODUCT_S_CAM_F5                0x0003		// SPCA500A (Minton)
#define	PRODUCT_DSC_350                 0x0003		// SPCA500A (D-Link)
//#define	PRODUCT_DSC_350F		0x0003		// SPCA500A
#define	PRODUCT_FAMILYCAM_300           0x0003		// SPCA500A (Trust)

#define	VENDOR_AIPTEK			0x08ca
//#define	PRODUCT_PENCAM_400		??
#define	PRODUCT_POCKET_DV               0x0103		// SPCA500C
#define	PRODUCT_EASY_CAM_DV             0x0103		// SPCA500C
#define PRODUCT_POCKET_DVII             0x0104      // SPCA533A [not yet]
#define PRODUCT_POCKET_DV3100           0x0106      // SPCA533A [not yet]
#define PRODUCT_TRUST_SPYCAM_100        0x0110      // Mars MR97310A-0B
#define PRODUCT_PENCAM_VGA_PLUS         0x0111      // Mars MR97310A-0B
#define PRODUCT_PHILIPS_K_007           0x504a      // SPCA504B (!)
#define PRODUCT_MINI_PENCAM_2M          0x2008      // SPCA504B
#define PRODUCT_POCKETCAM_3M            0x2010      // SPCA504B
#define PRODUCT_SLIM_3200               0x2012      // SPCA533A [not yet]
#define PRODUCT_POCKETCAM_2M            0x2016      // SPCA504B
#define PRODUCT_PENCAM_SD_2M            0x2018      // SPCA504B
#define PRODUCT_SLIM_3000F              0x2020      // SPCA533  [not yet]

#define VENDOR_GENERIC_TV8532   0x0923
#define PRODUCT_GENERIC_TV8532          0x010f      // TV8532

#define VENDOR_PIXART           0x093a
#define PRODUCT_MR97310_TYPE_A          0x010e      // Mars MR97310 [most likely]
#define PRODUCT_MR97310_TYPE_B          0x010f      // Mars MR97310 [most likely]
#define PRODUCT_PCAM                    0x050f      // Mars MR97311
#define PRODUCT_PAC207_BASE             0x2460      // PAC207 obviously
#define PRODUCT_PIXART_CIF_SINGLE_CHIP  0x2468      // Most common PAC207 camera Product ID
#define PRODUCT_PAC7311_GENERIC         0x2600      // PAC7311
#define PRODUCT_SPC_610NC               0x2601      // PAC7311
#define PRODUCT_SPC_500NC               0x2603      // PAC7312 (also a Typhoon?)
#define PRODUCT_TRUST_WB_300P           0x2608      // PAC7311
#define PRODUCT_TRUST_WB_3500P          0x260e      // PAC7311 (many cameras)
#define PRODUCT_PAC7302_GENERIC         0x2620      // PAC7311

#define VENDOR_JEILIN           0x0979
#define PRODUCT_JL2005A_TOY_CAMERA      0x0224      // JL2005ADriver

#define VENDOR_Z_STAR_MICRO     0x0ac8              // Z-Star Microelectronics Corp. aka Vimicro
#define PRODUCT_GENERIC_ZC0301B         0x301b      // ZC0301P
#define PRODUCT_GENERIC_ZC0302          0x0302      // ZC0302
#define PRODUCT_GENERIC_ZC0303B         0x303b      // ZC0301P
#define PRODUCT_GENERIC_ZC0305B         0x305b      // VC0301P
#define PRODUCT_VIMICRO_GENERIC_321     0x0321      // VC0321
#define PRODUCT_VIMICRO_GENERIC_323     0x0323      // VC0323
#define PRODUCT_SONY_C001               0xc001      // VC032x ?
#define PRODUCT_SONY_C002               0xc002      // VC032x ?

#define VENDOR_SONIX            0x0c45
#define VENDOR_SWEDA			0x0c45
#define PRODUCT_DC31UC                  0x8000      // Sonix 2028
#define PRODUCT_SMARTCAM_VGAS           0x8008		// Sonix 2028 something (Sweda)
#define PRODUCT_VIVICAM3350B            0x800A      // Sonix 2028

#define VENDOR_VISIONITE        0x0d81
#define PRODUCT_VCS_UC300               0x1900
#define PRODUCT_VCS_UM100               0x1910

#define VENDOR_FLYCAM           0x10fd
#define PRODUCT_FLYCAM_USB100           0x7e50      // SPCA561A

#define VENDOR_ANUBIS           0x10fd              // Anubis Electronics, Ltd
#define PRODUCT_TYPHOON_WEBSHOT_II_A    0x8050      // ZCZC0301P
#define PRODUCT_TYPHOON_WEBSHOT_II_B    0x804e      // ZCZC0301P
#define PRODUCT_TYPHOON_WEBSHOT_II_C    0x0128      // ZCZC0301P

#define VENDOR_AROWANA          0x1776
#define PRODUCT_300KCMOS                0x501c      // SPCA501A? [not yet]

#define VENDOR_LENOVO           0x17ef
#define PRODUCT_LENOVO_USB_WEBCAM       0x4802      // VC0323

#define VENDOR_PICO_INSTRUMENTS 0x18cd
#define PRODUCT_PICO_IMAGE_WEBCAM       0xcafe      // PicoDriver - UVC Bulk

#define VENDOR_SQ               0x2770
#define VENDOR_SQ905            0x2770
#define PRODUCT_SQ905                   0x9120      // common for many SQ905 cameras
#define PRODUCT_SQ905C                  0x905c      // uses 905C chip
#define PRODUCT_SQ913C                  0x913c      // uses 913C chip
#define PRODUCT_SQ930C                  0x930c      // uses 930C chip

#define	VENDOR_INTEL			0x8086
#define	PRODUCT_POCKET_PC_CS630         0x0630		// SPCA500A
#define	PRODUCT_PC_CAMERA_CS630         0x0630		// SPCA500A

#define VENDOR_SIGMA_APO        0xabcd
#define PRODUCT_PETCAM                  0xcdee      // SPCA561A

// do we need these?

#define PRODUCT_SPCA500                 0x500a
#define PRODUCT_SPCA500B                0x500b


